package vishnu.testvis.dendro;

import vishnu.testvis.object.*;

public class QSortForDocObj
{

    private boolean pauseTrue(int lo, int hi) throws Exception {
        return true;
    }
  
   void QuickSort(DocObj a[], int lo0, int hi0) throws Exception
   {
      int lo = lo0;
      int hi = hi0;
      int mid;

      if ( hi0 > lo0)
      {

           mid = a[ ( lo0 + hi0 ) / 2 ].getNumber();

         // loop through the array until indices cross
         while( lo <= hi )
         {
            /* find the first element that is greater than or equal to
             * the partition element starting from the left Index.
             */
             while( ( lo < hi0 ) && pauseTrue(lo0, hi0) && ( a[lo].getNumber() < mid ))
                 ++lo;

            /* find an element that is smaller than or equal to

             * the partition element starting from the right Index.
             */
             while( ( hi > lo0 ) && pauseTrue(lo0, hi0) && ( a[hi].getNumber() > mid ))
                 --hi;

            // if the indexes have not crossed, swap
            if( lo <= hi )
            {
               swap(a, lo, hi);
               ++lo;
               --hi;
            }
         }

         /* If the right index has not reached the left side of array
          * must now sort the left partition.

          */
         if( lo0 < hi )
            QuickSort( a, lo0, hi );

         /* If the left index has not reached the right side of array
          * must now sort the right partition.
          */
         if( lo < hi0 )
            QuickSort( a, lo, hi0 );

      }
   }

   private void swap(DocObj a[], int i, int j)
   {
      DocObj D;
      D = a[i];
      a[i] = a[j];
      a[j] = D;
   }

   public void sort(DocObj a[]) throws Exception
   {
      QuickSort(a, 0, a.length - 1);
   }
}
