package org.greenstone.gsdl3.gs3build.database;

public class GS3SQLSelect extends GS3SQLAction
{ GS3SQLWhere where;
  boolean     distinct;

  public GS3SQLSelect(String table)
  { super(table);
    this.where  = null;
    this.distinct = false;
  }
    
  public void setWhere(GS3SQLWhere where)
  { this.where = where;
  }

  public void setDistinct(boolean distinct)
  { this.distinct = distinct;
  }

  public String toString()
  { StringBuffer reply = new StringBuffer();
  
    reply.append("SELECT ");

    if (this.distinct)
    { reply.append("DISTINCT ");
    }
 
    for (int i = 0; i < this.values.size(); i ++)
    { GS3SQLValue value = (GS3SQLValue) this.values.get(i);
      if (i > 0)
	reply.append(", ");
      reply.append(value.field);
    }

    reply.append(" FROM ");
    reply.append(this.table);

    if (this.where != null)
    { reply.append(" WHERE ");
      reply.append(where.toString());
    }
    return reply.toString();
  }
}


